/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.RoleConfigManager
 *  fire.pb.buff.Module
 *  fire.pb.huoban.HuoBan
 *  fire.pb.huoban.HuoBanColumn
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.role.RoleConfig
 *  fire.pb.talk.MessageMgr
 *  mkdb.Procedure
 *  mkdb.logs.LogList
 *  mkio.Protocol
 *  xbean.Pod
 *  xbean.PvP1QueueRole
 *  xbean.PvP1Race
 *  xbean.PvP1RaceRole
 *  xtable.Properties
 *  xtable.Pvp1races
 */
package fire.pb.battle.pvp1;

import fire.pb.RoleConfigManager;
import fire.pb.battle.pvp1.PvP1Control;
import fire.pb.battle.pvp1.PvP1Helper;
import fire.pb.battle.pvp1.PvP1RoleProxy;
import fire.pb.battle.pvp1.PvP1RoleSingleScore;
import fire.pb.battle.pvp1.PvP1RoleSingleScoreMid;
import fire.pb.battle.pvp1.SPvP1RankingList;
import fire.pb.battle.pvp1.SPvP1ReadyFight;
import fire.pb.buff.Module;
import fire.pb.huoban.HuoBan;
import fire.pb.huoban.HuoBanColumn;
import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.role.RoleConfig;
import fire.pb.talk.MessageMgr;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.Set;
import mkdb.Procedure;
import mkdb.logs.LogList;
import mkio.Protocol;
import xbean.Pod;
import xbean.PvP1QueueRole;
import xbean.PvP1Race;
import xbean.PvP1RaceRole;
import xtable.Properties;
import xtable.Pvp1races;

public class PvP1RaceProxy {
    private final int grade;
    private PvP1Race xrace;
    private final boolean readonly;

    public static PvP1RaceProxy getPvP1RaceProxy(int grade) {
        boolean readonly = false;
        PvP1Race xrace = null;
        xrace = readonly ? Pvp1races.select((Integer)grade) : Pvp1races.get((Integer)grade);
        return new PvP1RaceProxy(grade, xrace, readonly);
    }

    private PvP1RaceProxy(int grade, PvP1Race xrace, boolean readonly) {
        this.grade = grade;
        this.xrace = xrace;
        this.readonly = readonly;
    }

    public int getGrade() {
        return this.grade;
    }

    public PvP1Race getXRace() {
        return this.xrace;
    }

    public boolean begin() {
        if (this.readonly) {
            throw new UnsupportedOperationException("cannot invoke while readonly");
        }
        this.end();
        this.xrace = Pod.newPvP1Race();
        Pvp1races.remove((Integer)this.grade);
        Pvp1races.insert((Integer)this.grade, (PvP1Race)this.xrace);
        if (PvP1Control.getLogger().isInfoEnabled()) {
            PvP1Control.getLogger().info((Object)("PVP1::[PvP1RaceProxy.begin] new race grade:" + this.grade));
        }
        return true;
    }

    public boolean end() {
        if (this.readonly) {
            throw new UnsupportedOperationException("cannot invoke while readonly");
        }
        if (this.xrace == null) {
            return false;
        }
        LinkedList<Long> roleinqueue = new LinkedList<Long>();
        for (PvP1QueueRole qrole : this.xrace.getWaitingqueue()) {
            roleinqueue.add(qrole.getRoleid());
        }
        Procedure.psendWhileCommit(roleinqueue, (Protocol)new SPvP1ReadyFight(0));
        for (Long roleId : this.xrace.getAllrolesid()) {
            if (Module.existState((long)roleId, (int)507004) || Module.existState((long)roleId, (int)507005) || Module.existState((long)roleId, (int)507027)) continue;
            PvP1Control.getInstance().forceLeave(roleId);
        }
        if (PvP1Control.getLogger().isInfoEnabled()) {
            PvP1Control.getLogger().info((Object)("PVP1::[PvP1RaceProxy.end] grade:" + this.grade));
        }
        return true;
    }

    public void clear() {
        if (this.readonly) {
            return;
        }
        Pvp1races.remove((Integer)this.grade);
        this.xrace = null;
        if (PvP1Control.getLogger().isInfoEnabled()) {
            PvP1Control.getLogger().info((Object)("PVP1::[PvP1RaceProxy.clear] remove race grade:" + this.grade));
        }
    }

    public boolean isOpening() {
        if (this.xrace == null) {
            return false;
        }
        return PvP1Control.getInstance().isFightTime();
    }

    public boolean roleIsValid(long roleId) {
        if (!this.isOpening()) {
            return false;
        }
        Role mapRole = RoleManager.getInstance().getRoleByID(roleId);
        if (mapRole == null) {
            return false;
        }
        int roleInRaceGrade = PvP1Helper.getRaceGradeByMapId(mapRole.getMapId());
        if (roleInRaceGrade <= 0) {
            return false;
        }
        return roleInRaceGrade == this.grade;
    }

    public boolean roleIsCanReady(long roleId) {
        if (!this.isOpening()) {
            return false;
        }
        if (!this.roleIsValid(roleId)) {
            return false;
        }
        if (Module.existState((long)roleId, (int)507006)) {
            MessageMgr.psendMsgNotify((long)roleId, (int)144300, null);
            return false;
        }
        int error = PvP1RaceProxy.checkHuoBan(roleId);
        if (error != 0) {
            switch (error) {
                default: {
                    MessageMgr.psendMsgNotify((long)roleId, (int)160496, null);
                    break;
                }
                case -3: {
                    MessageMgr.psendMsgNotify((long)roleId, (int)160333, null);
                }
            }
            return false;
        }
        PvP1RoleProxy pvpRole = PvP1RoleProxy.getPvP1RoleProxy(roleId, true);
        if (pvpRole.getBattleNum() >= 99) {
            MessageMgr.psendMsgNotify((long)roleId, (int)144297, (List)MessageMgr.getStringList((Object[])new Object[]{99}));
            return false;
        }
        return !Module.existState((long)roleId, (int)507004);
    }

    public static int checkHuoBan(long roleId) {
        HuoBanColumn huoBanCol = HuoBanColumn.getHuoBanColumn((long)roleId, (boolean)true);
        if (huoBanCol == null) {
            return -1;
        }
        List keys = huoBanCol.getFightHuobanKeys();
        if (keys.size() < 4) {
            return -2;
        }
        int count = 0;
        for (Integer key : keys) {
            HuoBan huoban = huoBanCol.getHuoBan(key.intValue());
            if (huoban == null || huoban.getType() == 1 || huoban.getType() == 2) continue;
            ++count;
        }
        int school = Properties.selectSchool((Long)roleId);
        RoleConfig roleConfig = RoleConfigManager.getRoleConfigBySchoolID((int)school);
        if (roleConfig != null && roleConfig.getType() != 1 && roleConfig.getType() != 2) {
            ++count;
        }
        if (count > 3) {
            return -3;
        }
        return 0;
    }

    public boolean roleEnter(long roleId) {
        if (this.xrace == null) {
            return false;
        }
        PvP1RoleProxy pvpRole = PvP1RoleProxy.getPvP1RoleProxy(roleId, false);
        this.xrace.getAllrolesid().remove(roleId);
        this.xrace.getAllrolesid().add(roleId);
        pvpRole.onEnter(this.grade);
        return true;
    }

    public boolean roleLeave(long roleId) {
        this.removeRoleFromWaitingQueue(roleId);
        if (this.xrace != null) {
            this.xrace.getAllrolesid().remove(roleId);
        }
        return true;
    }

    public boolean roleReady(long roleId) {
        if (!this.isOpening()) {
            MessageMgr.sendMsgNotify((long)roleId, (int)144298, null);
            return false;
        }
        long now = System.currentTimeMillis();
        if (!this.roleIsValid(roleId)) {
            return false;
        }
        if (!this.roleIsCanReady(roleId)) {
            return false;
        }
        boolean isWaiting = false;
        for (PvP1QueueRole role : this.xrace.getWaitingqueue()) {
            if (role.getRoleid() != roleId) continue;
            isWaiting = true;
        }
        if (!isWaiting) {
            PvP1QueueRole qrole = Pod.newPvP1QueueRole();
            qrole.setRoleid(roleId);
            qrole.setEnterqueuetime(now);
            this.xrace.getWaitingqueue().add(qrole);
        }
        Procedure.psendWhileCommit((long)roleId, (Protocol)new SPvP1ReadyFight(1));
        return true;
    }

    public boolean roleUnready(long roleId) {
        if (this.xrace == null) {
            return false;
        }
        if (this.removeRoleFromWaitingQueue(roleId) != null) {
            Procedure.psendWhileCommit((long)roleId, (Protocol)new SPvP1ReadyFight(0));
        }
        return true;
    }

    public void updateRankingList(long roleId, String name, int addScore, int score, int battleNum, int winNum, int continueWinNum) {
        if (this.xrace == null) {
            return;
        }
        this.updateScoreRankingList(roleId, name, addScore, score, battleNum, winNum);
    }

    private void updateScoreRankingList(long roleId, String name, int addScore, int score, int battleNum, int winNum) {
        PvP1RaceRole raceRole;
        if (addScore == 0 && (raceRole = this.getRoleFromScoreRankingList(roleId)) != null) {
            raceRole.setBattlenum(battleNum);
            raceRole.setWinnum(winNum);
            return;
        }
        PvP1RaceRole delRole = this.removeRoleFromScoreRankingList(roleId);
        ListIterator listIt = ((LogList)this.xrace.getAllroles()).listIterator();
        while (listIt.hasNext()) {
            PvP1RaceRole racerole = (PvP1RaceRole)listIt.next();
            if (score <= racerole.getScore()) continue;
            listIt.previous();
            if (delRole == null) {
                delRole = Pod.newPvP1RaceRole();
                delRole.setRoleid(roleId);
                delRole.setName(name);
            }
            delRole.setScore(score);
            delRole.setBattlenum(battleNum);
            delRole.setWinnum(winNum);
            listIt.add(delRole);
            return;
        }
        if (delRole == null) {
            delRole = Pod.newPvP1RaceRole();
            delRole.setRoleid(roleId);
            delRole.setName(name);
        }
        delRole.setScore(score);
        delRole.setBattlenum(battleNum);
        delRole.setWinnum(winNum);
        this.xrace.getAllroles().add(delRole);
    }

    private PvP1RaceRole getRoleFromScoreRankingList(long roleId) {
        if (this.xrace == null) {
            return null;
        }
        for (PvP1RaceRole raceRole : this.xrace.getAllroles()) {
            if (roleId != raceRole.getRoleid()) continue;
            return raceRole;
        }
        return null;
    }

    private PvP1RaceRole removeRoleFromScoreRankingList(long roleId) {
        if (this.xrace == null) {
            return null;
        }
        Iterator it = this.xrace.getAllroles().iterator();
        while (it.hasNext()) {
            PvP1RaceRole racerole = (PvP1RaceRole)it.next();
            if (roleId != racerole.getRoleid()) continue;
            it.remove();
            return racerole;
        }
        return null;
    }

    private PvP1QueueRole removeRoleFromWaitingQueue(long roleId) {
        if (this.xrace == null) {
            return null;
        }
        Iterator it = this.xrace.getWaitingqueue().iterator();
        while (it.hasNext()) {
            PvP1QueueRole racerole = (PvP1QueueRole)it.next();
            if (roleId != racerole.getRoleid()) continue;
            it.remove();
            return racerole;
        }
        return null;
    }

    public void sendSPvP1RankingList(long roleId) {
        if (!this.isOpening()) {
            return;
        }
        SPvP1RankingList send = new SPvP1RankingList();
        int max = 50;
        int i = 0;
        boolean findMyself = false;
        PvP1RoleSingleScoreMid self = new PvP1RoleSingleScoreMid();
        for (PvP1RaceRole raceRole : this.xrace.getAllroles()) {
            if (i < max) {
                PvP1RoleSingleScore singleScore = new PvP1RoleSingleScore();
                singleScore.roleid = raceRole.getRoleid();
                singleScore.rolename = raceRole.getName();
                singleScore.score = raceRole.getScore();
                singleScore.battlenum = (byte)raceRole.getBattlenum();
                singleScore.winnum = (byte)raceRole.getWinnum();
                send.rolescores.add(singleScore);
            }
            if (raceRole.getRoleid() == roleId) {
                self.index = (short)(i + 1);
                self.roleid = roleId;
                self.rolename = raceRole.getName();
                self.score = raceRole.getScore();
                self.battlenum = (byte)raceRole.getBattlenum();
                self.winnum = (byte)raceRole.getWinnum();
                findMyself = true;
            }
            if (++i < max || !findMyself) continue;
            break;
        }
        if (findMyself) {
            if (self.index > max) {
                self.index = 0;
            }
            send.rolescores3.add(self);
        }
        Procedure.psendWhileCommit((long)roleId, (Protocol)send);
    }

    public Set<Long> getBroadcastRoles(Set<Long> except) {
        HashSet<Long> allRoleIds = new HashSet<Long>();
        Iterator iterator = this.xrace.getAllrolesid().iterator();
        while (iterator.hasNext()) {
            long roleId = (Long)iterator.next();
            if (except.contains(roleId) || !this.roleIsValid(roleId) || Module.existState((long)roleId, (int)507004)) continue;
            allRoleIds.add(roleId);
        }
        return allRoleIds;
    }

    public boolean isReady(long roleId) {
        for (PvP1QueueRole role : this.xrace.getWaitingqueue()) {
            if (role.getRoleid() != roleId) continue;
            return true;
        }
        return false;
    }
}

